/*
This work is licensed under the Creative Commons 
Paternité - Pas d'Utilisation Commerciale - Partage à l'Identique 3.0 non transcrit License. 
To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/3.0/ 
or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
Auteur : Patrice Dalle - IRIS : Institut de Recherche et d'Innovation en langue des Signes
version : 1.0
*/


var ais = function() {  
	
	var largeurCadre;
	var hauteurBandeau = 30;
	var largeurImage;
	var hauteurImage;
	var largeurVideo;
	var hauteurVideo;
	var margeGImage;
	var margeTImage;
	
	var json_noms;
	var titre;
	var format_videos;
	var taille_image;
	
 	var endl = '\n';
	var separ = endl;
	var nbClics = 0;
	var listeClics= [];

	return{
			
	largeur : function(annotation){
			return annotation.rect[1][0] - annotation.rect[0][0];
		},

	hauteur : function(annotation){
		return annotation.rect[1][1] - annotation.rect[0][1];	
	},
	posElemX : function(annotation){
		return eval(annotation.rect[0][0])+margeGImage ;	
	},
	
	posElemY : function(annotation){
		return eval(annotation.rect[0][1]) ;	
	},
	
	afficher_image : function() {	
	ais.charger_ais();	
},

definir_zones : function(){
	
},

	charger_ais : function(){
		
		$.getJSON( "AIS_zones_actives.txt", function( data) {
				titre = data.titre;	
				format_videos = data.format_videos;
				taille_image = data.taille_image;
				json_annotations=data.annotations;

				ais.init_parametres();
				ais.afficher_annotations(json_annotations);				
				}
			)	
			
	},
	
	init_parametres : function(){
	 hauteurImage = taille_image.match(/[0-9]*$/);  //  idéalement  540 
	 largeurImage = taille_image.match(/^[0-9]*/);  //  idéalement 720 ou 960 (rapport 4x3 ou 16x9)
	 hauteurVideo = 270; 
	 if (format_videos == "4x3") {
		 largeurVideo = 360;
		}
		else {
			largeurVideo = 480;
		}
	 largeurCadre = (Math.max(largeurImage,largeurVideo))+40
	 margeGImage = (largeurCadre - largeurImage)/2;
	 margeTImage = hauteurBandeau+10+hauteurVideo+10+30;
			
	$("#titreLex").css("width", largeurCadre);
	$("#titreLex").css("height", hauteurBandeau);
	$("#titreLex").css("position", "fixed");
	
	$("#cadreVideo").css("width", largeurCadre);
	$("#cadreVideo").css("height", hauteurBandeau+10+hauteurVideo+10+20);
	$("#cadreVideo").css("top", hauteurBandeau);
	$("#cadreVideo").css("position", "fixed");
	

	$("#elemVideo").css("top", hauteurBandeau+10);
	$("#elemVideo").css("width", largeurVideo);  
	$("#elemVideo").css("height", hauteurVideo);  	
	$("#elemVideo").css("left", (largeurCadre-largeurVideo)/2);
	
	$("#cadreNom").css("width", largeurVideo); 
  $("#cadreNom").css("margin-top", hauteurBandeau+10+hauteurVideo+11); 
	$("#cadreNom").css({"height" : "20px", "font-size":"14px","text-align" : "center"});	
	$("#cadreNom").css("left", (largeurCadre-largeurVideo)/2); 	
	
	$("#conteneurImage").css("top", margeTImage);
	$("#conteneurImage").css("position", "absolute");
	$("#conteneurImage").css("width", largeurCadre);
	
	
	$("#cadreImage").css("margin-left", margeGImage); 
	},
	
 afficher_annotations : function(annotations) {
	var i;
	var imax=annotations.length;
		$("#titreLex").text(titre);		
		for ( i=0; i< imax; i++){
			$("#cadreImage").append(ais.afficher_element(json_annotations[i]));
 			$(".elemLex").css("position", "absolute"); 
		}				
 },	

 afficher_element : function(annotation){
	var nom = annotation["nom"];
	var video = "AIS_videos/"+annotation["nomFich"]
	var ch = "<div class='elemLex' style= \"left:" +ais.posElemX(annotation)+"px; " + "top:"+ais.posElemY(annotation)+"px; " +"\"  >" ; 
		ch += "<img src=\'AIS_code/vide.png\'"+ " alt=\'" +nom +"\'" 
					+ " width="+ais.largeur(annotation)+"px " + " height="+ ais.hauteur(annotation)+"px ";	
		ch += "onmouseover = \"$('.elemLex').css('cursor','pointer')\"";
		ch += "onmouseout = \"$('.elemLex').css('cursor','default')\"";
		ch += " onmousedown = \"ais.afficher_annotation(\'"+ nom+"\', '"+video+"')\" /> ";
			
		ch +=  "</div>";  				
	return ch;
},

 afficher_annotation : function(nom,video){
	ais.afficher_nom(nom);
	ais.afficher_video(video) 
},

 afficher_nom : function(nom){
	$("#cadreNom").text(nom);	
},

 afficher_video  : function(video){
	var ch = "";
  	ch += "<video  autoplay  controls height=\'"+ hauteurVideo+"\' width=\'" +largeurVideo+"\'> ";
		ch += "<source src=\'" +video+".mp4\'  type=\'video/mp4;  codecs=\"avc1.42E01E, mp4a.40.2\"\' >";  
		ch += "<source src=\'" +video+".webm\' type=\'video/webm; codecs=\"vp8, vorbis\"\' >";
		ch += "<source src=\'" +video+".ogv\' type=\'video/ogg; codecs=\"theora, vorbis\"\' >";  
		ch += "</video></div>";				
		
	$("#elemVideo").html(ch);
},

<!-- -------  Definition des zones ------     -->	
		
// efface le contenu de la zone active et remet le compte-ur de clics à 0
annulerZone: function(){
	$("#zoneActive").val("");	
	nbClics = 0;
	listeClics = [];
	// efface le tracé de la dernière zone active dans l'image
	$("#cadreImage .elemLex:last").remove();
},


// 	 sauvegarde les informations de la zone active courante dans la zone de texte "resultat"
validerZone: function(){
	var ch ="";	
	var zone = $("#zoneActive").val();
		
	ch +=  separ +	'{"nom" : "'+$("#nom").val()+'" , "nomFich" : "'+$("#nomFich").val()+'" , ';
	ch +=' "rect" : [' + zone + "]}";	
	$("#resultat").append(ch);
	separ = ","+endl;
	var n = $("#nomFich").val();
	$("#nom").val("");
	$("#nomFich").val("");
	$("#zoneActive").val("");	
	nbClics = 0;
	listeClics = [];
},

//  affichage des coordonnées du clic (coins opposés pour un rectangle) dans la case de saisie
posit: function(event){
	var x, y;
	var zone = $("#zoneActive").val();
	if(!event) event= window.event || e;
		x=event.clientX-12;
		y=event.clientY;
		listeClics[nbClics] = [x,y];
		nbClics +=1;
		if (nbClics != 1)
			zone+=" , ";
		zone+="["+x+","+y+"]";
		$("#zoneActive").val(zone);
		ais.test_fin_saisie_zone();
},

test_fin_saisie_zone : function(){

	switch($("#forme").val()){
		case  "rect" :
			if(nbClics ==2)
				ais.afficher_rectangle();			
			break;
			
			case "poly" :
			break;
	}
},

// affiche la zone active courante de type rectangle
afficher_rectangle : function(){
	var x1=listeClics[0][0];
	var y1=listeClics[0][1];
	var w=listeClics[1][0]-x1;
	var h=listeClics[1][1]-y1-4;
	var zch = "<div class='elemLex' style= \"left:" +x1+"px; " + "top:"+y1+"px; " +"\"  >" ; 
		zch += "<img src=\'AIS_code/vide.png\'"+ " alt=\'" +"nom de la zone" +"\'" ;
		zch += " width=\'"+w+"px\' " + " height=\'"+ h+"px\'  />";	
		$("#cadreImage").append(zch);
		$(".elemLex").css("opacity", 0.5);
		$(".elemLex").css("position", "absolute");
		$("#valider").focus();
},
	
// genere le contenu du fichier AIS_zones_actives.txt
 genereZA: function(){
	
	var zones = "{"+ endl ;
	zones +=  '"format_videos" : ' +'"' + $("#format").val()+ '"'  + "," + endl;
	zones +=  '"titre" : ' + '"' + $("#titre").val()+ '"'  + "," + endl;
	zones += '"taille_image" : ' + '"' + $("#taille_image").val()+ '"'  + "," + endl;
	zones += '"annotations" : ' + endl;
	zones += "[";
	zones += $("#resultat").val() + endl;
	zones +=  "]"+endl+"}"+endl;
	$("#resultat").val(zones);
	$("#consigne_svg").css("visibility","visible");	
	
	}


};
}();	
